package com.ruoyi.ss.vipOrder.service.impl;

import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.ss.channel.service.ChannelService;
import com.ruoyi.ss.user.service.UserService;
import com.ruoyi.ss.vipLevel.domain.VipLevelVO;
import com.ruoyi.ss.vipLevel.service.VipLevelService;
import com.ruoyi.ss.vipLevelSku.domain.VipLevelSkuVO;
import com.ruoyi.ss.vipLevelSku.service.VipLevelSkuService;
import com.ruoyi.ss.vipOrder.domain.bo.AddPayVipOrderBO;
import com.ruoyi.ss.vipOrder.domain.dto.AddPayVipOrderDTO;
import com.ruoyi.ss.vipOrder.service.VipOrderConverter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author wjh
 * 2025/1/17
 */
@Service
public class VipOrderConverterImpl implements VipOrderConverter {

    @Autowired
    private ChannelService channelService;

    @Autowired
    private VipLevelSkuService vipLevelSkuService;

    @Autowired
    private VipLevelService vipLevelService;

    @Autowired
    private UserService userService;

    @Override
    public AddPayVipOrderBO toBO(AddPayVipOrderDTO dto) {
        if (dto == null) {
            return null;
        }

        AddPayVipOrderBO bo = new AddPayVipOrderBO();
        bo.setDto(dto);
        // 支付渠道
        bo.setChannel(channelService.selectSmChannelByChannelId(dto.getChannelId()));

        // sku
        VipLevelSkuVO sku = vipLevelSkuService.selectVipLevelSkuById(dto.getSkuId());
        bo.setSku(sku);
        if (sku != null && sku.getLevelId() != null) {
            // 会员等级
            VipLevelVO level = vipLevelService.selectVipLevelById(sku.getLevelId());
            bo.setLevel(level);

            if (level != null && level.getMchId() != null) {
                // 商户
                bo.setMch(userService.selectSmUserByUserId(level.getMchId()));
            }
        }

        // 下单用户
        bo.setUser(userService.selectSmUserByUserId(SecurityUtils.getUserId()));

        return bo;
    }
}
