package com.ruoyi.ss.vipOrder.service.impl;

import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.ss.vipOrder.domain.VipOrder;
import com.ruoyi.ss.vipOrder.domain.VipOrderQuery;
import com.ruoyi.ss.vipOrder.domain.VipOrderVO;
import com.ruoyi.ss.vipOrder.domain.bo.AddPayVipOrderBO;
import com.ruoyi.ss.vipOrder.domain.vo.AddAndPayVO;
import com.ruoyi.ss.vipOrder.mapper.VipOrderMapper;
import com.ruoyi.ss.vipOrder.service.VipOrderService;
import com.ruoyi.ss.vipOrder.service.VipOrderValidator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 会员订单Service业务层处理
 *
 * @author ruoyi
 * @date 2025-01-16
 */
@Service
public class VipOrderServiceImpl implements VipOrderService
{
    @Autowired
    private VipOrderMapper vipOrderMapper;

    @Autowired
    private VipOrderValidator vipOrderValidator;

    /**
     * 查询会员订单
     *
     * @param id 会员订单主键
     * @return 会员订单
     */
    @Override
    public VipOrderVO selectVipOrderById(Long id)
    {
        return vipOrderMapper.selectVipOrderById(id);
    }

    /**
     * 查询会员订单列表
     *
     * @param vipOrder 会员订单
     * @return 会员订单
     */
    @Override
    public List<VipOrderVO> selectVipOrderList(VipOrderQuery vipOrder)
    {
        return vipOrderMapper.selectVipOrderList(vipOrder);
    }

    /**
     * 新增会员订单
     *
     * @param vipOrder 会员订单
     * @return 结果
     */
    @Override
    public int insertVipOrder(VipOrder vipOrder)
    {
        vipOrder.setCreateTime(DateUtils.getNowDate());
        return vipOrderMapper.insertVipOrder(vipOrder);
    }

    /**
     * 修改会员订单
     *
     * @param vipOrder 会员订单
     * @return 结果
     */
    @Override
    public int updateVipOrder(VipOrder vipOrder)
    {
        return vipOrderMapper.updateVipOrder(vipOrder);
    }

    /**
     * 批量删除会员订单
     *
     * @param ids 需要删除的会员订单主键
     * @return 结果
     */
    @Override
    public int deleteVipOrderByIds(Long[] ids)
    {
        return vipOrderMapper.deleteVipOrderByIds(ids);
    }

    /**
     * 删除会员订单信息
     *
     * @param id 会员订单主键
     * @return 结果
     */
    @Override
    public int deleteVipOrderById(Long id)
    {
        return vipOrderMapper.deleteVipOrderById(id);
    }

    @Override
    public AddAndPayVO addAndPay(AddPayVipOrderBO bo) {
        // 校验
        vipOrderValidator.preAddAndPay(bo);

        AddAndPayVO vo = new AddAndPayVO();

        // 创建订单

        // 创建支付单

        // 调起支付

        return vo;
    }
}
